<?php
class TabulizerModifyUrl2href {
    function modify(&$rows, $args = null) {
        if (empty($rows)) return;
    
        $num_of_rows = count($rows);
        $num_of_columns = count($rows[1]);        
        
        $target = (!empty($args))?$args:"_blank";     
		$url_regex = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S[^<]*)?/mi';		
        
        for ($i=1;$i<=$num_of_rows;$i++) {            
            for ($j=1;$j<=$num_of_columns;$j++) {     			
                if (preg_match_all($url_regex, $rows[$i][$j], $matches)) {                                                                                                        
                  $links = $matches[0];
                  foreach ($links as $link) {       
                      $replace_from_str = $link;
                      $replace_to_str = '<a href=\''.$link.'\' target=\''.$target.'\'>'.$link.'</a>';
                      $rows[$i][$j] = str_replace($replace_from_str, $replace_to_str, $rows[$i][$j]);
                  }                  
                }                                                
            }                                   
        }        
    }
}
?>